package cn.iocoder.yudao.module.member.service.holiday;

import java.time.LocalDate;
import java.util.*;
import javax.validation.*;
import cn.iocoder.yudao.module.member.controller.admin.holiday.vo.*;
import cn.iocoder.yudao.module.member.dal.dataobject.holiday.HolidayDO;
import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.framework.common.pojo.PageParam;

/**
 * 假期 Service 接口
 *
 * @author 我是秦俊旗
 */
public interface HolidayService {

    /**
     * 创建假期
     *
     * @param createReqVO 创建信息
     * @return 编号
     */
    Long createHoliday(@Valid HolidaySaveReqVO createReqVO);

    /**
     * 更新假期
     *
     * @param updateReqVO 更新信息
     */
    void updateHoliday(@Valid HolidaySaveReqVO updateReqVO);

    /**
     * 删除假期
     *
     * @param id 编号
     */
    void deleteHoliday(Long id);

    /**
     * 获得假期
     *
     * @param id 编号
     * @return 假期
     */
    HolidayDO getHoliday(Long id);

    /**
     * 获得假期分页
     *
     * @param pageReqVO 分页查询
     * @return 假期分页
     */
    PageResult<HolidayDO> getHolidayPage(HolidayPageReqVO pageReqVO);

    void getNextYearData(HolidayVO vo);
    /**
     * 判断今天是否是假期
     */
    Boolean checkHoliday();

    /**
     * 判断指定日期是否是假期
     */
    Boolean checkHoliday(String time);
}